var DSlider = function(container,opts){
    this.$tab = $(container).children('ul').eq(0);
    this.$tabs = this.$tab.children('li');
    this.opts = opts;
    this.selected = 0;
    this.oldSelected = 0;
    this._size = $(container).width();
    this._length = this.$tabs.length;

    this._touch();
};

DSlider.prototype._touch = function(){
    var _this = this,
        _startX = 0,
        _endX = 0,
        _touchMove = function(){
            event.preventDefault();
        },
        _touchEnd = function(){
            _endX = event.changedTouches[0].pageX - _startX;
            if(Math.abs(_endX) > 50){
                $(_this.$tab).unbind('touchend',_touchMove);
                $(_this.$tab).unbind('touchend',_touchEnd);
                _this.selected = _this.selected + (_endX > 0 ? -1 : 1);
                _this.selected > _this._length - 1 && (_this.selected = _this._length - 1);
                _this.selected < 0 && (_this.selected = 0);
                $(_this.$tab).css('-webkit-transform','translate3d( ' + (_this.selected === 0 ? '0' : '-' + _this._size * _this.selected + 'px' ) + ', 0, 0)');
                if(_this.selected !== _this.oldSelected){
                    _this.selectChange();
                }
            }
        };

    this.$tab.on({
        touchstart : function(){
            _startX = event.changedTouches[0].pageX;
            $(_this.$tab).bind('touchend',_touchEnd);
            $(_this.$tab).bind('touchmove',_touchMove);
        }
    });

};
DSlider.prototype.selectChange = function(fn){
    var _this = this;
    _this.oldSelected = _this.selected;

    _this.opts.selectChange && _this.opts.selectChange(_this.selected);
};